chmod testsuite and link testsuite.

Chmod ?

In this testsuite after change file mode bits, we are comparing file mode with expected ones.

One additional "." is coming with modes (actual result). That?s why test cases are getting failed.

This patch will remove additional "." from actual result.

Link ?
Added more test cases.
diff --git a/scripts/test/link.test b/scripts/test/link.test
index 3bfdc1f..769a7b6 100755
--- a/scripts/test/link.test
+++ b/scripts/test/link.test
@@ -1,8 +1,26 @@
 #!/bin/bash
 
-[ -e testing.sh ] && . testing.sh
+# Copyright 2014 Divya Kothari <divya.s.kothari@gmail.com>
+# Copyright 2014 Naha Maggu <maggu.neha@gmail.com>
+
+[ -f testing.sh ] && . testing.sh
+
+#testing "name" "command" "result" "infile" "stdin"
 
 echo "" >foo
-testing "link has same inode" "link foo bar && stat -c '%DI%i bar'" "stat -c '%DI%i' foo" "" ""
 testing "link fails on non-existent file" "link foo/foo baz || echo GOOD" "GOOD\n" "" ""
 rm -f foo bar
+
+echo file1 > file
+testing "ln create_hardlink" "link file hlink && [ file -ef hlink ] &&
+          echo 'yes'; rm  -rf hlink" "yes\n" "" ""
+
+echo hlink1 > hlink
+set +e
+testing "ln preserves_hardlinks" "link file hlink 2>/dev/null || echo 'yes'; rm -rf hlink" \
+          "yes\n" "" ""
+
+echo file1 > file
+testing "ln create_hardlink_and_remove_sourcefile" "link file hlink &&
+          [ file -ef hlink ] && rm -rf file && [ -f hlink ] && echo 'yes'; rm -f file hlink" \
+          "yes\n" "" ""